var Model = function(){
    this.saveData = function(params){
        var hostobject = {};
        hostobject.date = params.date;
        hostobject.tfhours = params.tfhours;
        hostobject.hide_seconds = params.hide_seconds;
        hostobject.keep_counting = params.keep_counting;
        hostobject.clock_option = params.clock_option;
        hostobject.firstTimeHelperTextTriggered = params.firstTimeHelperTextTriggered;
        hostobject.isSettingsOpen = params.isSettingsOpen;
        hostobject.currentTime = new Date();
        NB.persist.save("date", hostobject);
    };
    this.loadData = function () {
        var params = NB.persist.load("date");
        if (params) {
            params = JSON.parse(params);
            params.loaded = true;
        } else {
            params = {};
            params.date = new Date();
            params.tfhours = false;
            params.hide_seconds = false;
            params.keep_counting = true;
            params.clock_option = "analog";
            params.firstTimeHelperTextTriggered = false;
            params.isSettingsOpen = false;
            params.currentTime = new Date();
            params.loaded = false;
        }

        params = readFlash(params);
        return params;
    };
    var readFlash = function(params) {
        var updateDataFlashId = NB.persist.load("updateDataFlashId");
        if (updateDataFlashId) {
            var updateData = NB.persist.load("updateData");
            if (updateDataFlashId == "Clock - original") {
                params.clock_option = "analog_digital";
                
                var extractTime = function (src) {
                    var ix = src.indexOf(':');
                    var result = new Date();
                    if (ix == -1) {
                        return result;
                    }
                    var hh = (Number(src.substring(0, ix)))/2;
                    src = src.substring(ix + 1);
                    ix = src.indexOf(':');
                    if (ix == -1) {
                        return result;
                    }
                    var mm = Number(src.substring(0, ix));
                    src = src.substring(ix + 1);
                    ix = src.indexOf(':');
                    if (ix == -1) {
                        return result;
                    }
                    var ss = Number(src.substring(0, ix));
                    src = src.substring(ix + 1);
                    if (src == 'PM') {
                        hh += 12;
                    }
                    return new Date(2010, 0, 0, hh, mm, ss);
                };

                if (updateData) {
                    var xml = $.parseXML(updateData);
                    var persistenceinfoNode = xml.getElementsByTagName("persistenceinfo")[0];
                    if (persistenceinfoNode) {
                        var newTime = extractTime(persistenceinfoNode.textContent);
                        params.date = newTime;
                    }
                    var showDisplayNode = xml.getElementsByTagName("showDisplay")[0];
                    if (showDisplayNode) {
                        var showDisplay = (showDisplayNode.textContent == "false") ? false : true;
                        params.clock_option = (!showDisplay) ? "analog" : "analog_digital";
                    }
                }
            } else if (updateDataFlashId == "Clock-red") {
                params.keep_counting = true;
                params.hide_seconds = false;
                params.clock_option = "analog";
            }
            params.loaded = true;
        }
        NB.persist.remove("updateData");
        NB.persist.remove("updateDataFlashId");

        return params;
    };
}